﻿IF	OBJECT_ID('tempdb..#tmpUDF') IS NOT NULL
		DROP TABLE #tmpUDF

	CREATE TABLE #tmpUDF ( Error VARCHAR(8000) )


Declare @strObjName as sysname, @strSQL as varchar(1000)
Declare curObj Cursor FOR
select Name as objName
From sys.objects WHERE Type='IF'

Open curObj

Fetch Next from curObj Into @strObjName

While (@@FETCH_STATUS = 0)
Begin
Print @strObjName + ' will be refreshed now'
Set @strSQL = 'exec sys.sp_refreshsqlmodule  ' + @strObjName
BEGIN TRY
	begin tran
	exec (@strSQL)
	commit
END TRY
BEGIN CATCH
	rollback
    -- Execute error retrieval routine.
    Insert #tmpUDF (Error) VALUES(@strObjName+':'+ERROR_MESSAGE()) 
END CATCH;


Fetch Next from curObj Into @strObjName
End

Close curObj
Deallocate curObj
SELECT * FROM #tmpUDF

IF	OBJECT_ID('tempdb..#tmpUDF') IS NOT NULL
		DROP TABLE #tmpUDF


GO
